<template>
    <div class="col-xs-12">
        <h1 v-if="block.id">Edit {{block.name}}</h1>
        <h1 v-else>Add custom attribute</h1>
        <div class="clearfix">
            <ul class="nav nav-tabs">
                <li class="active" v-bind:class="{active:settings}">
                    <a href="#" @click="activateTab('settings', $event)">Attriubute settings</a>
                </li>
                <li v-bind:class="{active:values}" v-if="isMultivalue">
                    <a href="#" @click="activateTab('values', $event)">Attribute values</a>
                </li>
            </ul>
        </div>
        <div class="settings" v-if="settings">
            <h2>Attributes settings</h2>
            <div class="form-group">
                <label>Attribute name</label>
                <input type="text" v-model="block.name" id="Name" name="attr_name" class="form-control">
                <errors :validation="validation" input="Name"></errors>
            </div>
            <div class="form-group">
                <label>Attribute code</label>
                <div v-if="!block.id && !block.system">
                    <input type="text" name="attr_code" v-model="block.code" class="form-control">
                    <errors :validation="validation" input="Code"></errors>
                </div>
                <div v-else>{{block.code}}</div>
            </div>
            <div class="form-group">
                <label>Attribute type</label>
                <div v-if="!block.id && !block.system">
                    <select v-model="block.type" @change="selectType()">
                        <option v-for="type in attribute_types" v-bind:value="type.code">{{type.name}}</option>
                    </select>
                    <errors :validation="validation" input="Type"></errors>
                </div>
                <div v-else>{{block.type}}</div>
            </div>
            <div class="form-group">
                <label>Position on the product page</label>
                <input type="number" min="1" name="product_position" v-model="block.position" class="form-control">
                <errors :validation="validation" input="ColumnPosition"></errors>
            </div>
            <div class="form-group">
                <label>Is column?</label>
                <input type="checkbox" name="is_column" v-model="block.is_column" :checked="false"
                       class="form-control">
            </div>
            <div v-show="block.is_column">
                <div class="form-group">
                    <label>Column position</label>
                    <input type="number" min="1" name="column_position" v-model="block.column_position"
                           class="form-control">
                    <errors :validation="validation" input="Position"></errors>
                </div>
            </div>

            <div class="clearfix">
                <span class="btn btn-default custom-attrs-form__save" @click="saveAttribute()">Save</span>
                <span class="btn btn-danger repeater__button--delete" @click="deleteAttribute()" v-if="!block.system">Delete</span>
            </div>
        </div>

        <div class="values" v-if="this.block.is_column && values">
            <h2>Attribute values</h2>
            <div class="form-inline" v-for="value in attribute_values">
                <div class="form-group">
                    <input type="text" v-model="value.option" class="form-control">
                </div>
                <button @click="deleteValue(value)" class="btn button-danger">x</button>
            </div>
            <button @click="addValue">New Value</button>
            <button @click="saveAttributeValue">Save Values</button>
        </div>
    </div>
</template>

<script>
    import errors from './errors.vue'
    export default {
        data(){
            return {
                settings: true,
                values: false,
                attribute_values: [{option: '', id: ''}],
                block: {},
                validation: {},
                attribute_types: [{}],
                isMultivalue: false
            }
        },
        route: {
            data(transition) {
                var id = this.$route.params.id;
                if (id != undefined) {
                    return this.$http.get('/api/v1/product-attributes/attribute/' + id).then(function (res) {
//						console.log(res);
                        if (res.data.type == "select" || res.data.type == "multiselect") {
                            this.isMultivalue = true;
                        }
                        return {
                            block: res.data
                        }
                    });
                }
            }
        },
        ready: function () {
            this.getTypeOptions().then(function (res) {
                this.attribute_types = res;
            });
        },
        methods: {
            deleteAttribute: function () {
                if (this.block.id) {
                    this.$http.delete('/api/v1/product-attributes/delete/' + this.block.id).then(function (res) {
                        console.log(res.data);
                    });
                } else {
                    console.log(res.data);
                }
            },
            saveAttribute: function () {
                if (!this.block.is_column) {
                    delete this.block.column_position;
                }
                if (this.block.id) {
                    this.$http.put('/api/v1/product-attributes/update/' + this.block.id, this.block).then(function (res) {
                        console.log(res.data);
                    })
                } else {
                    this.$http.post('/api/v1/product-attributes/create', this.block).then(function (res) {
                        //console.log(res.data);
                        this.validation = res.data;

                    })
                }
            },
            getTypeOptions: function () {
                return this.$http.get('/api/v1/settings/attribute_types').then(function (res) {
                    return res.data.data
                })
            },
            selectType: function () {
                if (this.block.type == 'select' || this.block.type == 'multiselect') {
                    this.isMultivalue = true;
                } else {
                    this.isMultivalue = false;
                }
            },
            activateTab: function (tab, event) {
                event.preventDefault();
                if (tab == 'settings') {
                    this.settings = true;
                    this.values = false;
                } else if (tab == 'values') {
                    this.values = true;
                    this.settings = false;
                    this.getAttributeOptions().then(function (res) {
                        this.attribute_values = res;
                    });
                }
            },
            addValue: function () {
                this.attribute_values.push({option: '', id: ''});
            },
            saveAttributeValue: function () {
                var attr_values = {
                    attribute: this.block.id,
                    values: this.attribute_values,
                };
                this.$http.post('/api/v1/product-attribute-values/create', attr_values).then(function (res) {
                    this.attribute_values = res.data;
//                    this.validation = res.data;

                })
            },
            getAttributeOptions: function () {
                return this.$http.get('/api/v1/product-attribute-values/' + this.block.id).then(function (res) {
                    return res.data;
                })
            },
            deleteValue: function (value) {
                if (value.id) {
                    this.$http.delete('/api/v1/product-attribute-values/delete/' + value.id).then(function (res) {
                        this.attribute_values.$remove(value)
                    });
                }
            },
        },
        components: {errors}
    }

</script>

<style scoped>

</style>
